Package org.apache.commons.pool2

# Interface ObjectPool<T>

Type Parameters:
  `T` - Type of element pooled in this pool.

All Superinterfaces:
  `AutoCloseable`, `Closeable`

All Known Implementing Classes:
  `BaseObjectPool`, `GenericObjectPool`, `ProxiedObjectPool`, `SoftReferenceObjectPool`

public interface ObjectPool<T> extends Closeable
A pooling simple interface.

Example of use:

     Object obj = null;

     try {
         obj = pool.borrowObject();
         try {
             //...use the object...
         } catch (Exception e) {
             // invalidate the object
             pool.invalidateObject(obj);
             // do not return the object to the pool twice
             obj = null;
         } finally {
             // make sure the object is returned to the pool
             if (null != obj) {
                 pool.returnObject(obj);
            }
         }
     } catch(Exception e) {
           // failed to borrow an object
     }

See `BaseObjectPool` for a simple base implementation.

Since:
  2.0
See Also:
  - `PooledObjectFactory`
  - `KeyedObjectPool`
  - `BaseObjectPool`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addObject()`
  Creates an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool.
  `default void`
  `addObjects(int count)`
  Calls `addObject()` `count` number of times.
  `T`
  `borrowObject()`
  Borrows an instance from this pool.
  `void`
  `clear()`
  Clears any objects sitting idle in the pool, releasing any associated resources (optional operation).
  `void`
  `close()`
  Closes this pool, and free any resources associated with it.
  `int`
  `getNumActive()`
  Gets the number of instances currently borrowed from this pool.
  `int`
  `getNumIdle()`
  Gets the number of instances currently idle in this pool.
  `void`
  `invalidateObject(T obj)`
  Invalidates an object from the pool.
  `default void`
  `invalidateObject(T obj, DestroyMode destroyMode)`
  Invalidates an object from the pool, using the provided `DestroyMode`
  `void`
  `returnObject(T obj)`
  Returns an instance to the pool.

- ## Method Details

  - ### addObject

    void addObject() throws Exception
    Creates an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool. `addObject` is useful for "pre-loading" a pool with idle objects. (Optional operation).
    Throws:
      `Exception` - when `PooledObjectFactory.makeObject()` fails.
      `IllegalStateException` - after `close()` has been called on this pool.
      `UnsupportedOperationException` - when this pool cannot add new idle objects.

  - ### addObjects

    default void addObjects(int count) throws Exception
    Calls `addObject()` `count` number of times.
    Parameters:
      `count` - the number of idle objects to add.
    Throws:
      `Exception` - See `addObject()`.
    Since:
      2.8.0

  - ### borrowObject

    T borrowObject() throws Exception
    Borrows an instance from this pool.

    Instances returned from this method will have been either newly created with `PooledObjectFactory.makeObject()` or will be a previously idle object and have been activated with `PooledObjectFactory.activateObject(org.apache.commons.pool2.PooledObject<T>)` and then validated with `PooledObjectFactory.validateObject(org.apache.commons.pool2.PooledObject<T>)`.

    By contract, clients must return the borrowed instance using `returnObject(T)`, `invalidateObject(T)`, or a related method as defined in an implementation or sub-interface.

    The behavior of this method when the pool has been exhausted is not strictly specified (although it may be specified by implementations).

    Returns:
      an instance from this pool.
    Throws:
      `IllegalStateException` - after `close` has been called on this pool.
      `Exception` - when `PooledObjectFactory.makeObject()` throws an exception.
      `NoSuchElementException` - when the pool is exhausted and cannot or will not return another instance.

  - ### clear

    void clear() throws Exception
    Clears any objects sitting idle in the pool, releasing any associated resources (optional operation). Idle objects cleared must be `PooledObjectFactory.destroyObject(PooledObject)`.
    Throws:
      `UnsupportedOperationException` - if this implementation does not support the operation
      `Exception` - if the pool cannot be cleared

  - ### close

    void close()
    Closes this pool, and free any resources associated with it.

    Calling `addObject()` or `borrowObject()` after invoking this method on a pool will cause them to throw an `IllegalStateException`.

    Implementations should silently fail if not all resources can be freed.

    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`

  - ### getNumActive

    int getNumActive()
    Gets the number of instances currently borrowed from this pool. Returns a negative value if this information is not available.
    Returns:
      the number of instances currently borrowed from this pool.

  - ### getNumIdle

    int getNumIdle()
    Gets the number of instances currently idle in this pool. This may be considered an approximation of the number of objects that can be `borrowed` without creating any new instances. Returns a negative value if this information is not available.
    Returns:
      the number of instances currently idle in this pool.

  - ### invalidateObject

    void invalidateObject(T obj) throws Exception
    Invalidates an object from the pool.

    By contract, `obj` must have been obtained using `borrowObject()` or a related method as defined in an implementation or sub-interface.

    This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

    Parameters:
      `obj` - a `borrowed` instance to be disposed.
    Throws:
      `Exception` - if the instance cannot be invalidated

  - ### invalidateObject

    default void invalidateObject(T obj, DestroyMode destroyMode) throws Exception
    Invalidates an object from the pool, using the provided `DestroyMode`

    By contract, `obj` must have been obtained using `borrowObject()` or a related method as defined in an implementation or sub-interface.

    This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

    Parameters:
      `obj` - a `borrowed` instance to be disposed.
      `destroyMode` - destroy activation context provided to the factory
    Throws:
      `Exception` - if the instance cannot be invalidated
    Since:
      2.9.0

  - ### returnObject

    void returnObject(T obj) throws Exception
    Returns an instance to the pool. By contract, `obj` must have been obtained using `borrowObject()` or a related method as defined in an implementation or sub-interface.
    Parameters:
      `obj` - a `borrowed` instance to be returned.
    Throws:
      `IllegalStateException` - if an attempt is made to return an object to the pool that is in any state other than allocated (i.e. borrowed). Attempting to return an object more than once or attempting to return an object that was never borrowed from the pool will trigger this exception.
      `Exception` - if an instance cannot be returned to the pool